diff --git a/hledger-api/hledger-api.info b/hledger-api/hledger-api.info
index 61682c085..ee65a103f 100644
--- a/hledger-api/hledger-api.info
+++ b/hledger-api/hledger-api.info
@@ -1,4 +1,4 @@
-This is hledger-api.info, produced by makeinfo version 6.0 from stdin.
+This is hledger-api.info, produced by makeinfo version 6.5 from stdin.
 
 
 File: hledger-api.info,  Node: Top,  Next: OPTIONS,  Up: (dir)
diff --git a/hledger-lib/hledger_csv.info b/hledger-lib/hledger_csv.info
index 8bd1f0da7..62f6ef556 100644
--- a/hledger-lib/hledger_csv.info
+++ b/hledger-lib/hledger_csv.info
@@ -1,4 +1,4 @@
-This is hledger_csv.info, produced by makeinfo version 6.0 from stdin.
+This is hledger_csv.info, produced by makeinfo version 6.5 from stdin.
 
 
 File: hledger_csv.info,  Node: Top,  Next: CSV RULES,  Up: (dir)
diff --git a/hledger-lib/hledger_journal.info b/hledger-lib/hledger_journal.info
index 07f2ca7ec..d35404cb2 100644
--- a/hledger-lib/hledger_journal.info
+++ b/hledger-lib/hledger_journal.info
@@ -1,4 +1,4 @@
-This is hledger_journal.info, produced by makeinfo version 6.0 from
+This is hledger_journal.info, produced by makeinfo version 6.5 from
 stdin.
 
 
@@ -57,10 +57,12 @@ assisted by the helper modes for emacs or vim.
 * Menu:
 
 * FILE FORMAT::
+* Periodic transactions::
+* Automated posting rules::
 * EDITOR SUPPORT::
 
 
-File: hledger_journal.info,  Node: FILE FORMAT,  Next: EDITOR SUPPORT,  Prev: Top,  Up: Top
+File: hledger_journal.info,  Node: FILE FORMAT,  Next: Periodic transactions,  Prev: Top,  Up: Top
 
 1 FILE FORMAT
 *************
@@ -270,13 +272,13 @@ toggle transaction status with C-c C-e, or posting status with C-c C-c.
    What "uncleared", "pending", and "cleared" actually mean is up to
 you.  Here's one suggestion:
 
-status      meaning
+status     meaning
 --------------------------------------------------------------------------
-uncleared   recorded but not yet reconciled; needs review
-pending     tentatively reconciled (if needed, eg during a big
-            reconciliation)
-cleared     complete, reconciled as far as possible, and considered
-            correct
+uncleared  recorded but not yet reconciled; needs review
+pending    tentatively reconciled (if needed, eg during a big
+           reconciliation)
+cleared    complete, reconciled as far as possible, and considered
+           correct
 
    With this scheme, you would use '-PC' to see the current balance at
 your bank, '-U' to see things which will probably hit your bank soon
@@ -568,7 +570,7 @@ equals sign; instead it is calculated automatically so as to satisfy the
 assertion.  This can be a convenience during data entry, eg when setting
 opening balances:
 
-; starting a new journal, set asset account balances
+; starting a new journal, set asset account balances 
 2016/1/1 opening balances
   assets:checking            = $409.32
   assets:savings             = $735.24
@@ -1054,9 +1056,67 @@ current file.  Glob patterns ('*') are not currently supported.
 include journal, timeclock or timedot files, but not CSV files.
 
 
-File: hledger_journal.info,  Node: EDITOR SUPPORT,  Prev: FILE FORMAT,  Up: Top
+File: hledger_journal.info,  Node: Periodic transactions,  Next: Automated posting rules,  Prev: FILE FORMAT,  Up: Top
 
-2 EDITOR SUPPORT
+2 Periodic transactions
+***********************
+
+A periodic transaction starts with a tilde '~' in place of a date
+followed by a period expression:
+
+~ weekly
+  assets:bank:checking   $400 ; paycheck
+  income:acme inc
+
+   Periodic transactions are used for budgeting and forecasting only,
+they have no effect without the '--forecast' or '--budget' option
+specified.  For examples and details, see Budgeting and Forecasting.
+
+
+File: hledger_journal.info,  Node: Automated posting rules,  Next: EDITOR SUPPORT,  Prev: Periodic transactions,  Up: Top
+
+3 Automated posting rules
+*************************
+
+Autopated posting rule starts with an equal sign '=' in place of a date,
+followed by a query:
+
+= expenses:gifts
+    budget:gifts  *-1
+    assets:budget  *1
+
+   When '--auto' option is specified on the command line, automated
+posting rule will add its postings to all transactions that match the
+query.
+
+   If amount in the automated posting rule includes commodity name, new
+posting will be made in the given commodity, otherwise commodity of the
+matched transaction will be used.
+
+   When amount in the automated posting rule begins with the '*', amount
+will be treated as a multiplier that is applied to the amount of the
+first posting in the matched transaction.
+
+   In example above, every transaction in 'expenses:gifts' account will
+have two additional postings added to it: amount of the original gift
+will be debited from 'budget:gifts' and credited into 'assets:budget':
+
+; Original transaction
+2017-12-14
+  expenses:gifts  $20
+  assets
+
+; With automated postings applied
+2017/12/14
+    expenses:gifts             $20
+    assets
+    budget:gifts              $-20
+    assets:budget              $20
+
+
+File: hledger_journal.info,  Node: EDITOR SUPPORT,  Prev: Automated posting rules,  Up: Top
+
+4 EDITOR SUPPORT
 ****************
 
 Add-on modes exist for various text editors, to make working with
@@ -1078,85 +1138,89 @@ Code
 
 Tag Table:
 Node: Top76
-Node: FILE FORMAT2370
-Ref: #file-format2494
-Node: Transactions2717
-Ref: #transactions2838
-Node: Postings3522
-Ref: #postings3649
-Node: Dates4644
-Ref: #dates4759
-Node: Simple dates4824
-Ref: #simple-dates4950
-Node: Secondary dates5316
-Ref: #secondary-dates5470
-Node: Posting dates7033
-Ref: #posting-dates7162
-Node: Status8536
-Ref: #status8656
-Node: Description10370
-Ref: #description10508
-Node: Payee and note10827
-Ref: #payee-and-note10941
-Node: Account names11183
-Ref: #account-names11326
-Node: Amounts11813
-Ref: #amounts11949
-Node: Virtual Postings14540
-Ref: #virtual-postings14699
-Node: Balance Assertions15919
-Ref: #balance-assertions16094
-Node: Assertions and ordering16990
-Ref: #assertions-and-ordering17176
-Node: Assertions and included files17876
-Ref: #assertions-and-included-files18117
-Node: Assertions and multiple -f options18450
-Ref: #assertions-and-multiple--f-options18704
-Node: Assertions and commodities18836
-Ref: #assertions-and-commodities19071
-Node: Assertions and subaccounts19767
-Ref: #assertions-and-subaccounts19999
-Node: Assertions and virtual postings20520
-Ref: #assertions-and-virtual-postings20727
-Node: Balance Assignments20869
-Ref: #balance-assignments21038
-Node: Prices22157
-Ref: #prices22290
-Node: Transaction prices22341
-Ref: #transaction-prices22486
-Node: Market prices24642
-Ref: #market-prices24777
-Node: Comments25737
-Ref: #comments25859
-Node: Tags27101
-Ref: #tags27219
-Node: Directives28621
-Ref: #directives28734
-Node: Account aliases28927
-Ref: #account-aliases29071
-Node: Basic aliases29675
-Ref: #basic-aliases29818
-Node: Regex aliases30508
-Ref: #regex-aliases30676
-Node: Multiple aliases31394
-Ref: #multiple-aliases31566
-Node: end aliases32064
-Ref: #end-aliases32204
-Node: account directive32305
-Ref: #account-directive32485
-Node: apply account directive32781
-Ref: #apply-account-directive32977
-Node: Multi-line comments33636
-Ref: #multi-line-comments33826
-Node: commodity directive33954
-Ref: #commodity-directive34138
-Node: Default commodity35010
-Ref: #default-commodity35183
-Node: Default year35720
-Ref: #default-year35885
-Node: Including other files36308
-Ref: #including-other-files36465
-Node: EDITOR SUPPORT36862
-Ref: #editor-support36980
+Node: FILE FORMAT2424
+Ref: #file-format2555
+Node: Transactions2778
+Ref: #transactions2899
+Node: Postings3583
+Ref: #postings3710
+Node: Dates4705
+Ref: #dates4820
+Node: Simple dates4885
+Ref: #simple-dates5011
+Node: Secondary dates5377
+Ref: #secondary-dates5531
+Node: Posting dates7094
+Ref: #posting-dates7223
+Node: Status8597
+Ref: #status8717
+Node: Description10425
+Ref: #description10563
+Node: Payee and note10882
+Ref: #payee-and-note10996
+Node: Account names11238
+Ref: #account-names11381
+Node: Amounts11868
+Ref: #amounts12004
+Node: Virtual Postings14595
+Ref: #virtual-postings14754
+Node: Balance Assertions15974
+Ref: #balance-assertions16149
+Node: Assertions and ordering17045
+Ref: #assertions-and-ordering17231
+Node: Assertions and included files17931
+Ref: #assertions-and-included-files18172
+Node: Assertions and multiple -f options18505
+Ref: #assertions-and-multiple--f-options18759
+Node: Assertions and commodities18891
+Ref: #assertions-and-commodities19126
+Node: Assertions and subaccounts19822
+Ref: #assertions-and-subaccounts20054
+Node: Assertions and virtual postings20575
+Ref: #assertions-and-virtual-postings20782
+Node: Balance Assignments20924
+Ref: #balance-assignments21093
+Node: Prices22213
+Ref: #prices22346
+Node: Transaction prices22397
+Ref: #transaction-prices22542
+Node: Market prices24698
+Ref: #market-prices24833
+Node: Comments25793
+Ref: #comments25915
+Node: Tags27157
+Ref: #tags27275
+Node: Directives28677
+Ref: #directives28790
+Node: Account aliases28983
+Ref: #account-aliases29127
+Node: Basic aliases29731
+Ref: #basic-aliases29874
+Node: Regex aliases30564
+Ref: #regex-aliases30732
+Node: Multiple aliases31450
+Ref: #multiple-aliases31622
+Node: end aliases32120
+Ref: #end-aliases32260
+Node: account directive32361
+Ref: #account-directive32541
+Node: apply account directive32837
+Ref: #apply-account-directive33033
+Node: Multi-line comments33692
+Ref: #multi-line-comments33882
+Node: commodity directive34010
+Ref: #commodity-directive34194
+Node: Default commodity35066
+Ref: #default-commodity35239
+Node: Default year35776
+Ref: #default-year35941
+Node: Including other files36364
+Ref: #including-other-files36521
+Node: Periodic transactions36918
+Ref: #periodic-transactions37089
+Node: Automated posting rules37464
+Ref: #automated-posting-rules37642
+Node: EDITOR SUPPORT38751
+Ref: #editor-support38881
 
 End Tag Table
diff --git a/hledger-lib/hledger_timeclock.info b/hledger-lib/hledger_timeclock.info
index dd3b0f80a..4dae5ee9e 100644
--- a/hledger-lib/hledger_timeclock.info
+++ b/hledger-lib/hledger_timeclock.info
@@ -1,4 +1,4 @@
-This is hledger_timeclock.info, produced by makeinfo version 6.0 from
+This is hledger_timeclock.info, produced by makeinfo version 6.5 from
 stdin.
 
 
diff --git a/hledger-lib/hledger_timedot.info b/hledger-lib/hledger_timedot.info
index aff215245..cce6b11cc 100644
--- a/hledger-lib/hledger_timedot.info
+++ b/hledger-lib/hledger_timedot.info
@@ -1,4 +1,4 @@
-This is hledger_timedot.info, produced by makeinfo version 6.0 from
+This is hledger_timedot.info, produced by makeinfo version 6.5 from
 stdin.
 
 
@@ -53,7 +53,7 @@ example:
 # on this day, 6h was spent on client work, 1.5h on haskell FOSS work, etc.
 2016/2/1
 inc:client1   .... .... .... .... .... ....
-fos:haskell   .... ..
+fos:haskell   .... .. 
 biz:research  .
 
 2016/2/2
@@ -79,17 +79,17 @@ $ hledger -f t.timedot print date:2016/2/2
 $ hledger -f t.timedot bal --daily --tree
 Balance changes in 2016/02/01-2016/02/03:
 
-            ||  2016/02/01d  2016/02/02d  2016/02/03d
+            ||  2016/02/01d  2016/02/02d  2016/02/03d 
 ============++========================================
- biz        ||         0.25         0.25         1.00
-   research ||         0.25         0.25         1.00
- fos        ||         1.50            0         3.00
-   haskell  ||         1.50            0            0
-   hledger  ||            0            0         3.00
- inc        ||         6.00         2.00         4.00
-   client1  ||         6.00         2.00         4.00
+ biz        ||         0.25         0.25         1.00 
+   research ||         0.25         0.25         1.00 
+ fos        ||         1.50            0         3.00 
+   haskell  ||         1.50            0            0 
+   hledger  ||            0            0         3.00 
+ inc        ||         6.00         2.00         4.00 
+   client1  ||         6.00         2.00         4.00 
 ------------++----------------------------------------
-            ||         7.75         2.25         8.00
+            ||         7.75         2.25         8.00 
 
    I prefer to use period for separating account components.  We can
 make this work with an account alias:
diff --git a/hledger-ui/hledger-ui.info b/hledger-ui/hledger-ui.info
index 8d7cfd1a8..49f51e34d 100644
--- a/hledger-ui/hledger-ui.info
+++ b/hledger-ui/hledger-ui.info
@@ -1,4 +1,4 @@
-This is hledger-ui.info, produced by makeinfo version 6.0 from stdin.
+This is hledger-ui.info, produced by makeinfo version 6.5 from stdin.
 
 
 File: hledger-ui.info,  Node: Top,  Next: OPTIONS,  Up: (dir)
@@ -100,7 +100,7 @@ the data.
 '-p --period=PERIODEXP'
 
      set start date, end date, and/or reporting interval all at once
-     (overrides the flags above)
+     using period expressions syntax (overrides the flags above)
 '--date2'
 
      match the secondary date instead (see command help for other
@@ -131,6 +131,17 @@ the data.
 
      convert amounts to their market value on the report end date (using
      the most recent applicable market price, if any)
+'--forecast'
+
+     generate forecast transactions from [periodic
+     transaction]((journal.html#periodic-transactions) rules.  Each
+     periodic transaction rule will generate forecast transactions,
+     beginning the day after the last recorded journal transaction, and
+     ending 6 months from today, or at the specified report end date.
+'--auto'
+
+     apply automated posting rules to modify transactions where
+     applicable (can combine with -forecast).
 
    When a reporting option appears more than once in the command line,
 the last one takes precedence.
@@ -371,17 +382,17 @@ Tag Table:
 Node: Top71
 Node: OPTIONS821
 Ref: #options918
-Node: KEYS3855
-Ref: #keys3950
-Node: SCREENS6909
-Ref: #screens6994
-Node: Accounts screen7084
-Ref: #accounts-screen7212
-Node: Register screen9442
-Ref: #register-screen9597
-Node: Transaction screen11671
-Ref: #transaction-screen11829
-Node: Error screen12699
-Ref: #error-screen12821
+Node: KEYS4350
+Ref: #keys4445
+Node: SCREENS7404
+Ref: #screens7489
+Node: Accounts screen7579
+Ref: #accounts-screen7707
+Node: Register screen9937
+Ref: #register-screen10092
+Node: Transaction screen12166
+Ref: #transaction-screen12324
+Node: Error screen13194
+Ref: #error-screen13316
 
 End Tag Table
diff --git a/hledger-web/hledger-web.info b/hledger-web/hledger-web.info
index 8491130d5..eedefbed0 100644
--- a/hledger-web/hledger-web.info
+++ b/hledger-web/hledger-web.info
@@ -1,4 +1,4 @@
-This is hledger-web.info, produced by makeinfo version 6.0 from stdin.
+This is hledger-web.info, produced by makeinfo version 6.5 from stdin.
 
 
 File: hledger-web.info,  Node: Top,  Next: OPTIONS,  Up: (dir)
@@ -145,7 +145,7 @@ options as shown above.
 '-p --period=PERIODEXP'
 
      set start date, end date, and/or reporting interval all at once
-     (overrides the flags above)
+     using period expressions syntax (overrides the flags above)
 '--date2'
 
      match the secondary date instead (see command help for other
@@ -176,6 +176,17 @@ options as shown above.
 
      convert amounts to their market value on the report end date (using
      the most recent applicable market price, if any)
+'--forecast'
+
+     generate forecast transactions from [periodic
+     transaction]((journal.html#periodic-transactions) rules.  Each
+     periodic transaction rule will generate forecast transactions,
+     beginning the day after the last recorded journal transaction, and
+     ending 6 months from today, or at the specified report end date.
+'--auto'
+
+     apply automated posting rules to modify transactions where
+     applicable (can combine with -forecast).
 
    When a reporting option appears more than once in the command line,
 the last one takes precedence.
